<?php
/**
 * @license MIT
 *
 * Modified by caseproof on 01-August-2024 using Strauss.
 * @see https://github.com/BrianHenryIE/strauss
 */

namespace WishListMember\Infusionsoft\Api\Rest;

use WishListMember\Infusionsoft\Api\Rest\Traits\CannotCreate;
use WishListMember\Infusionsoft\Api\Rest\Traits\CannotDelete;
use WishListMember\Infusionsoft\Api\Rest\Traits\CannotFind;
use WishListMember\Infusionsoft\Api\Rest\Traits\CannotModel;
use WishListMember\Infusionsoft\Api\Rest\Traits\CannotSave;
use WishListMember\Infusionsoft\Api\Rest\Traits\CannotSync;
use WishListMember\Infusionsoft\Api\Rest\Traits\CannotWhere;

class MerchantService extends RestModel
{
    use CannotCreate, CannotDelete, CannotFind, CannotModel, CannotSave, CannotSync, CannotWhere;

    public $full_url = 'https://api.infusionsoft.com/crm/rest/v1/merchants';
    public $return_key = 'merchant_accounts';
}